/control-d | Type: Application | PCID required: Yes
Tools
control_d_delete_access
Delete Learned IP Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
device_id | string | No | — | Primary key of the device. |
ips[] | any[] | No | — | IPv4 or IPv6 addresses |
control_d_delete_devices_by_device_id
Delete Endpoint Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
device_id | string | Yes | — | Device/Resolver ID |
control_d_delete_profiles_by_profile_id
Profiles - Delete Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
control_d_delete_profiles_by_profile_id_groups_by_folder
Rule Folders - Delete Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
folder | string | Yes | — | Folder ID |
do | string | No | — | (Optional) Add a rule type to a folder. All rules inside will inherit rule type. |
name | string | No | — | (Optional) Rename the folder. |
status | string | No | — | Status of the folder and all rules inside. |
via | string | No | — | (Optional) Add spoof IP or hostname, or proxy identiifer if do=2 or do=3. |
control_d_delete_profiles_by_profile_id_rules_by_hostname
Custom Rules - Delete Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
hostname | string | Yes | — | Hostname to delete |
control_d_get_access
List Known IPs Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
device_id | string | Yes | — | (Required) Primary key of the device. |
control_d_get_analytics_endpoints
List Storage Regionscontrol_d_get_analytics_levels
List Log Levelscontrol_d_get_billing_payments
Paymentscontrol_d_get_billing_products
Active Productscontrol_d_get_billing_subscriptions
Subscriptionscontrol_d_get_devices
List All Endpointscontrol_d_get_devices_types
List Endpoint Typescontrol_d_get_ip
Return IPcontrol_d_get_network
Network Statscontrol_d_get_organizations_members
View Memberscontrol_d_get_organizations_organization
View Organization Infocontrol_d_get_organizations_sub_organizations
View Sub-Organizationscontrol_d_get_profiles
Profiles - Listcontrol_d_get_profiles_by_profile_id_default
Default Rule - List Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
control_d_get_profiles_by_profile_id_filters
Filters - List Native Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
control_d_get_profiles_by_profile_id_filters_external
Filters - List 3rd Party Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
control_d_get_profiles_by_profile_id_groups
Rule Folders - LIst Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
control_d_get_profiles_by_profile_id_rules_by_folder_id
Custom Rules - List Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
folder_id | string | Yes | — | Folder ID (0 or omit for root) |
control_d_get_profiles_by_profile_id_services
Services - List Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
control_d_get_profiles_options
Profiles - List Optionscontrol_d_get_proxies
List Proxiescontrol_d_get_services_categories
List Service Categoriescontrol_d_get_services_categories_by_category
LIst All Services Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
category | string | Yes | — | Category name |
control_d_get_users
User Datacontrol_d_post_access
Learn New IP Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
device_id | string | Yes | — | Primary key of the device. |
ips[] | any[] | Yes | — | IPv4 or IPv6 addresses |
control_d_post_devices
Create Endpoint Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
client_count | string | Yes | — | Number of devices using this Endpoint |
ddns_ext_host | string | No | — | DDNS hostname to query to learn new IPs |
ddns_ext_status | integer | No | — | Status of DDNS based IP learning |
ddns_status | integer | No | — | Status of DDNS endpoint that exposes last used IP. |
ddns_subdomain | string | No | — | DDNS subdomain to expose the IP on |
desc | string | No | — | Add a description or comment to the device |
icon | string | Yes | — | Device icon/type |
learn_ip | integer | No | — | Enable or disable automatic IP learning and logging. 0 to disable, 1 to enable. |
legacy_ipv4_status | integer | No | — | Set this to 1 to generate a legacy IPv4 (and IPv6) DNS resolver. |
name | string | Yes | — | Device name |
profile_id | string | Yes | — | Primary key of main profile to enforce on this device |
profile_id2 | string | No | — | Primary key of a second profile to enforce |
remap_client_id | string | No | — | Remap source device + client ID to a new device |
remap_device_id | string | No | — | Remap source device + client ID to a new device |
restricted | integer | No | — | Make this device restricted, only previously authorized IPs will be able to query against it |
stats | integer | No | — | Set analytics level on device. 0 = off, 1 = basic, 2 = full |
control_d_post_organizations_suborg
Create Sub-Organization Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
address | string | No | — | (Optional) Physical address of this organization |
contact_email | string | Yes | — | (Required) Primary contact for this sub-organization |
contact_name | string | No | — | (Optional) Contact name for the person responsible for this organization |
contact_phone | string | No | — | (Optional) Phone number associated with this organization |
name | string | Yes | — | (Required) Organization name |
parent_profile | string | No | — | (Optional) Global Profile ID (PK) to enforce on all created Devices |
stats_endpoint | string | Yes | — | (Required) Primary key of desired storage region. See GET /analytics/endpoints |
twofa_req | integer | Yes | — | (Required) Is 2FA/MFA required for memberts of this org. 0 = no, 1 = yes |
website | string | No | — | (Optional) Website URL of this organization |
control_d_post_profiles
Profiles - Create Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
clone_profile_id | string | No | — | Primary key of profile to clone. If ommited, a blank profile is created. |
name | string | Yes | — | Name of the new profile |
control_d_post_profiles_by_profile_id_groups
Rule Folders - Create Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
do | integer | Yes | — | Add a rule type to a folder. All rules inside will inherit rule type. 0 = BLOCK. 1 = BYPASS, 2 = SPOOF, 3 = REDIRECT |
name | string | Yes | — | Name of your folder |
status | integer | Yes | — | Status of the folder and all rules inside |
via | string | No | — | Add spoof IP or hostname, or proxy identiifer if do=2 or do=3. |
control_d_post_profiles_by_profile_id_rules
Custom Rules - Create Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
do | integer | Yes | — | Rule type. 0 = BLOCK. 1 = BYPASS, 2 = SPOOF, 3 = REDIRECT. <<glossary:Do>> |
group | integer | No | — | Optional ID of the folder to create this rule in, root folder if ommited |
hostnames[] | any[] | Yes | — | Array of hostnames |
status | integer | Yes | — | Status of the rule |
via | string | No | — | Spoof/Redirect target. If SPOOF, this can be an IPv4 or hostname. If REDIRECT, this must be a valid proxy identifier. <<glossary:Via>> |
via_v6 | string | No | — | If SPOOF this can be a valid IPv6 address (AAAA record) |
control_d_put_devices_by_device_id
Modify Endpoint Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
device_id | string | Yes | — | Device/Resolver ID |
bump_tls | integer | No | — | Enable or disable experimental ECH support and TLS bumping |
client_count | string | No | — | Number of devices using this Endpoint |
ctrld_custom_config | string | No | — | ctrld .toml config file to deploy |
ddns_ext_host | string | No | — | DDNS hostname to query to learn new IPs |
ddns_ext_status | integer | No | — | Status of DDNS based IP learning. 0 to disable, 1 to enable. |
ddns_status | integer | No | — | Status of public DDNS endpoint. 1 = enabled, 0 = disable. |
ddns_subdomain | string | No | — | DDNS subdomain to expose the IP on |
desc | string | No | — | Add a description or comment to the device |
learn_ip | integer | No | — | Enable or disable automatic IP learning and logging. 0 to disable, 1 to enable. |
legacy_ipv4_status | integer | No | — | Set this to 1 to generate a legacy IPv4 (and IPv6) DNS resolver, 0 to remove existing one. |
name | string | No | — | New Device name |
profile_id | string | No | — | Primary key of main profile to enforce on this device |
profile_id2 | string | No | — | Primary key of a second profile to enforce -1 to remove. |
restricted | integer | No | — | Make this device restricted. 0 to disable, 1 to enable. |
stats | integer | No | — | Set analytics level on device. 0 = off, 1 = basic, 2 = full |
status | integer | No | — | Update device status. 0 - pending, 1 - active, 2 - soft disabled, 3 - hard disabled |
control_d_put_organizations
Modify Organization Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
address | string | No | — | Physical address of this organization |
contact_email | string | No | — | Primary contact for this sub-organization |
contact_name | string | No | — | Contact name for the person responsible for this organization |
contact_phone | string | No | — | Phone number associated with this organization |
name | string | No | — | Organization name |
parent_profile | string | No | — | Global Profile ID (PK) to enforce on all created Devices |
stats_endpoint | string | No | — | Primary key of desired storage region. See GET /analytics/endpoints |
twofa_req | integer | No | — | Is 2FA/MFA required for memberts of this org. 0 = no, 1 = yes |
website | string | No | — | Website URL of this organization |
control_d_put_profiles_by_profile_id
Profiles - Modify Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
disable_ttl | integer | No | — | Disable profile until specified unix timestamp. ttl = 0 disables previous deactivation. |
lock_message | string | No | — | Optional message to error our with when locked profile is modified |
lock_status | integer | No | — | Lock/unlock a profile from being edited. |
name | string | No | — | Rename profile to this name |
password | string | No | — | Account password when unlocking a profile |
control_d_put_profiles_by_profile_id_default
Default Rule - Modify Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
do | integer | No | — | Rule type. 0 = BLOCK. 1 = BYPASS, 2 = SPOOF, 3 = REDIRECT |
status | integer | No | — | Status of the rule. |
via | string | No | — | Spoof/Redirect target. If SPOOF, this can be an IP or hostname. If REDIRECT, this must be a valid proxy identifier. |
control_d_put_profiles_by_profile_id_filters
Filters - Batch Modify Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
filters | object[] | No | — | The filters value |
control_d_put_profiles_by_profile_id_filters_filter_by_filter
Filters - Modify Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
filter | string | Yes | — | Filter name |
status | integer | No | — | Status of the filter. 1 to enable, 0 to disable. |
control_d_put_profiles_by_profile_id_groups_by_folder
Rule Folders - Modify Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
folder | string | Yes | — | Folder ID |
do | integer | No | — | Add a rule type to a folder. All rules inside will inherit rule type |
name | string | No | — | Rename the folder to this name |
status | integer | No | — | Status of the folder and all rules inside |
via | string | No | — | Add spoof IP or hostname, or proxy identifer if do=2 or do=3 |
control_d_put_profiles_by_profile_id_options_by_name
Profiles - Modify Options Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
name | string | Yes | — | Option name |
status | integer | No | — | Status of the Profile Option. 1 to enable, 0 to disable |
value | string | No | — | Optional value of the option to set |
control_d_put_profiles_by_profile_id_rules
Custom Rules - Modify Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
do | integer | No | — | Rule type. 0 = BLOCK. 1 = BYPASS, 2 = SPOOF, 3 = REDIRECT. |
group | integer | No | — | ID of the folder to create this rule in. |
hostnames[] | any[] | No | — | Array of hostnames |
status | integer | No | — | Status of the rule. |
via | string | No | — | Spoof/Redirect target. If SPOOF, this can be an IP or hostname. If REDIRECT, this must be a valid proxy identifier. <<glossary:Via>> |
via_v6 | string | No | — | If SPOOF this can be a valid IPv6 address (AAAA record) |
control_d_put_profiles_by_profile_id_services_by_service
Services - Modify Parameters:| Parameter | Type | Required | Default | Description |
|---|---|---|---|---|
profile_id | string | Yes | — | Primary key (PK) of the profile |
service | string | Yes | — | Service name |
do | integer | No | — | Rule type. 0 = BLOCK. 1 = BYPASS, 2 = SPOOF, 3 = REDIRECT. |
status | integer | No | — | Rule status. 0 = disable. 1 = enabled |
via | string | No | — | Spoof/Redirect target. If SPOOF, this can be an IPv4 or hostname. If REDIRECT, this must be a valid proxy identifier. <<glossary:Via>> |
via_v6 | string | No | — | If SPOOF this can be a valid IPv6 address (AAAA record) |

